unit mainForm;

//Der Deklarationsteil der Unit.
interface

//'uses' Klausel wie bisher, einziger Unterschied sind nun die
//diversen automatisch von Delphi eingebundenen Units fr die GUI.
//Wir werden uns spter damit im Einzelnen befassen.
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

//'type' Klausel ebenfalls wie bisher in Programmen. Neu ist lediglich
//das Schlsselwort class, da wir die OOP erstmal beiseite
//lassen wollen stellt euch das vorerst als eine Ansammlung von Prozeduren
//vor, auf die ihr mittels <Intanzbezeichner>.<Methodenname> zugreift.
//Analog und ebenfalls record-hnlich geht das fr Variablen.
type
  TcalculateForm = class(TForm)
    firstOperandMaskEdit: TMaskEdit;
    additionButton: TButton;
    differenceButton: TButton;
    multiplicationButton: TButton;
    divisionButton: TButton;
    secondOperandMaskEdit: TMaskEdit;
    Label1: TLabel;
    resultEdit: TEdit;
    exitButton: TButton;
    procedure additionButtonClick(Sender: TObject);
    procedure exitButtonClick(Sender: TObject);
    procedure multiplicationButtonClick(Sender: TObject);
    procedure differenceButtonClick(Sender: TObject);
    procedure divisionButtonClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
//Die einzige (globale) Variable ist eine Instanz der
//TcalculateForm-Klasse: Unser Hauptfenster.
  calculateForm: TcalculateForm;


//Der Implementationsteil zum 'Fllen' der oben angekndigten Methoden.
implementation

//Compiler Schalter fr die zugehrige Formatdatei
{$R *.DFM}

//Die Ereignisprozedur fr den 'Additionsknopf' (vorerst: wird
//aufgerufen wenn entsprechender Button bettigt wird, genauere
//Erluterungen zur Funktionsweise des Message-Handling spter).
procedure TcalculateForm.additionButtonClick(Sender: TObject);
begin
  //(Erluterungen zu den anderen Ereignisprozeduren analog.)
  //
  //nachfolgend eine bisher sicherlich unbekannte Struktur fr
  //einen Anweisungsblock:
  //
  //try <Anweisungen> except on <Ausnahme> do <Anweisung> end;
  //Der Anweisungblock wird normal abgearbeitet, tritt eine Ausnahme
  //auf wird in den except-Block gesprungen und der entsprechende
  //Ausnahmefall so vorhanden abgearbeitet. Die ganze Kombination
  //kann natrlich auch mittels entsprechender if-then-else-Konstrukte
  //erfat werden, wir kommen in den allernchsten Terminen dann
  //ausfhrlich zur Ausnahmebehandlung (exceptions).
  try
    //Hier 'resultEdit.Text' wird wie oben kurz angedeutet auf das Feld
    //(die Variable) einer Klasseninstanz (hier: das Eingabefeld fr die
    //Ausgabe) von der Syntax her analog zum record zugegriffen.
    //
    //die neuen Funktionen sind:
    //function IntToStr(Value: Integer): string; overload;
    //- konvertiert einen Integer in einen String
    //function StrToInt(const S: string): Integer;
    //- konvertiert einen String in einen Integer
    //
    //Zur Bedeutung des reservierten Wortes overload kommen wir
    //im Rahmen der OOP-Einfhrung, bis dahin kann es ignoriert werden.
    resultEdit.Text:=IntToStr(StrToInt(firstOperandMaskEdit.Text)
    +StrToInt(secondOperandMaskEdit.Text));
  except
    on EConvertError do resultEdit.Text:='fehlerhafter Operand';
    on EIntOverflow do resultEdit.Text:='Integer-berlauf';
  end;
end;

//Die Ereignisprozedur fr den 'Multiplikations'-Button
procedure TcalculateForm.multiplicationButtonClick(Sender: TObject);
begin
  try
    resultEdit.Text:=IntToStr(StrToInt(firstOperandMaskEdit.Text)
    *StrToInt(secondOperandMaskEdit.Text));
  except
    on EConvertError do resultEdit.Text:='fehlerhafter Operand';
    on EIntOverflow do resultEdit.Text:='Integer-berlauf';
  end;
end;

//Die Ereignisprozedur fr den 'Subtraktions'-Button
procedure TcalculateForm.differenceButtonClick(Sender: TObject);
begin
  try
    resultEdit.Text:=IntToStr(StrToInt(firstOperandMaskEdit.Text)
    -StrToInt(secondOperandMaskEdit.Text));
  except
    on EConvertError do resultEdit.Text:='fehlerhafter Operand';
    on EIntOverflow do resultEdit.Text:='Integer-berlauf';
  end;
end;

//Die Ereignisprozedur fr den 'Divisions'-Button
procedure TcalculateForm.divisionButtonClick(Sender: TObject);
begin
  try
    resultEdit.Text:=IntToStr(StrToInt(firstOperandMaskEdit.Text)
    div StrToInt(secondOperandMaskEdit.Text));
  except
    on EConvertError do resultEdit.Text:='fehlerhafter Operand';
    on EIntOverflow do resultEdit.Text:='Integer-berlauf';
    on EDivByZero do resultEdit.Text:='Null-Division';
  end;
end;

//Die Ereignisprozedur fr den 'Beenden'-Button
procedure TcalculateForm.exitButtonClick(Sender: TObject);
begin
  //Beenden der Anwendung, zur genauen Funktionsweise und Alternativen
  //spter mehr.
  Application.Terminate;
end;

end.
